﻿using System.Windows;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;
using System.Collections.ObjectModel;
using System.Windows.Forms;
using System.Drawing.Printing;
using System.Drawing;

namespace Post7598Sample
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            wpfMap1.MapUnit = GeographyUnit.DecimalDegree;
            wpfMap1.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean);

            string shapeFile = @"C:\Program Files\ThinkGeo\Map Suite Desktop Evaluation Edition 3.0\Samples\SampleData\Data\Countries02.shp";
            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(shapeFile);
            worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
            worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay staticOverlay = new LayerOverlay();
            staticOverlay.Layers.Add("WorldLayer", worldLayer);

            wpfMap1.Overlays.Add("WorldOverlay", staticOverlay);

            wpfMap1.CurrentExtent = new RectangleShape(-133.2515625, 89.2484375, 126.9046875, -88.290625);

            wpfMap1.Refresh();
        }

        private void Print_Click(object sender, RoutedEventArgs e)
        {
            PrinterGeoCanvas printerGeoCanvas = new PrinterGeoCanvas();
            PrintDialog Dialog1 = new PrintDialog();

            Collection<SimpleCandidate> labelsInLayers = new Collection<SimpleCandidate>();
            PrintDocument document = new PrintDocument();
            printerGeoCanvas.DrawingArea = new Rectangle(0, 0, (int)wpfMap1.Width, (int)wpfMap1.Height);
            printerGeoCanvas.BeginDrawing(document, wpfMap1.CurrentExtent, GeographyUnit.DecimalDegree);
            foreach (LayerOverlay layeroverlay in wpfMap1.Overlays)
            {
                foreach (Layer layer in layeroverlay.Layers)
                {
                    layer.Open();
                    layer.Draw(printerGeoCanvas, labelsInLayers);
                    layer.Close();
                    printerGeoCanvas.Flush();

                }
            }

            Dialog1.Document = document;
            Dialog1.AllowSomePages = true;
            DialogResult results = Dialog1.ShowDialog();
            if (results.ToString() == "OK")
            {

                printerGeoCanvas.EndDrawing();
            }
        }
    }
}
